Spheral++ provides a steerable parallel environment for performing coupled hydrodynamical & gravitational numerical simulations. Hydrodynamics and gravity are modelled using particle based methods (SPH and N-Body).

Some useful features are
- Total energy conserving compatible hydro mode.
- ASPH (Adapative Smoothed Particle Hydrodynamics) algorithm.
- CRKSPH (Conservative Reproducing Kernel Hydrodyamics) is also available.
- Oct-tree based N-Body gravity.
- Fluid and solid material modeling.
- Damage and fracture modeling in solids.
- Scriptable user interface in python.
- Extensible by user in python, including the ability to write new physics packages in python.

Basic documentation is under development at https://spheral.readthedocs.io/en/latest/

Release and license:

Copyright (c) 2012, Lawrence Livermore National Security, LLC.  
Produced at the Lawrence Livermore National Laboratory  
Written by J. Michael Owen <mikeowen@llnl.gov>  
LLNL-CODE-561852  
All rights reserved.

Please see full license at https://github.com/jmikeowen/spheral/blob/master/License.txt
